package tcc.haruki.elgamal.util;

import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.SecretKeySpec;

public class CriptografiaSimetricaImpl extends ICriptografiaSimetrica {
	
	public byte[] encrypt(byte[] m) throws IllegalBlockSizeException, BadPaddingException, NoSuchAlgorithmException, NoSuchPaddingException, InvalidKeyException {
		SecretKeySpec skeySpec = new SecretKeySpec(this.chaveSimetrica, "AES");
		  
		Cipher cipher = Cipher.getInstance("AES");  
		  
        cipher.init(Cipher.ENCRYPT_MODE, skeySpec);  
  
        byte[] encrypted = cipher.doFinal(m);
        
        return encrypted; 
	}
	
	
	public byte[] decrypt(byte[] m) throws IllegalBlockSizeException, BadPaddingException, NoSuchAlgorithmException, NoSuchPaddingException, InvalidKeyException {
		SecretKeySpec skeySpec = new SecretKeySpec(this.chaveSimetrica, "AES");
		  
		Cipher cipher = Cipher.getInstance("AES");
		
		cipher.init(Cipher.DECRYPT_MODE, skeySpec);
		
		byte[] original = cipher.doFinal(m);
		
		return original;
	}
	
	public void setChaveSimetrica(byte[] key) {
		this.chaveSimetrica = new byte[16];
		int i;
		for (i = 0; i < 16 - key.length; i++) {
			this.chaveSimetrica[i] = 0;
		}
		for (int j = 0; j < key.length && j < 16; j++) {
			this.chaveSimetrica[i++] = key[j];
		}
	}
}
